Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class ByteArrayOutputStream

    java.lang.Object
      |
      +--java.io.OutputStream
            |
            +--java.io.ByteArrayOutputStream

public class ByteArrayOutputStream
extends OutputStream

This class implements an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it. The data can be retrieved using `toByteArray()` and `toString()`.

Since:
  JDK1.0

Field Summary
`protected byte[]` | `buf` The buffer where data is stored.
`protected int` | `count` The number of valid bytes in the buffer.

Constructor Summary
`ByteArrayOutputStream()` Creates a new byte array output stream.
`ByteArrayOutputStream(int size)` Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

Method Summary
`void` | `close()` Closes this output stream and releases any system resources associated with this stream.
`void` | `reset()` Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the ouput stream is discarded.
`int` | `size()` Returns the current size of the buffer.
`byte[]` | `toByteArray()` Creates a newly allocated byte array.
`String` | `toString()` Converts the buffer's contents into a string, translating bytes into characters according to the platform's default character encoding.
`String` | `toString(String enc)` Converts the buffer's contents into a string, translating bytes into characters according to the specified character encoding.
`void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.
`void` | `write(int b)` Writes the specified byte to this byte array output stream.
`void` | `writeTo(OutputStream out)` Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

Methods inherited from class java.io.OutputStream
`flush, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### buf

    protected byte[] buf

  The buffer where data is stored.

### count

    protected int count

  The number of valid bytes in the buffer.

Constructor Detail

### ByteArrayOutputStream

    public ByteArrayOutputStream()

  Creates a new byte array output stream. The buffer capacity is initially 32 bytes, though its size increases if necessary.

### ByteArrayOutputStream

    public ByteArrayOutputStream(int size)

  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.
  Parameters:
    `size` - the initial size.
  Throws:
    `IllegalArgumentException` - if size is negative.

Method Detail

### write

    public void write(int b)

  Writes the specified byte to this byte array output stream.
  Overrides:
    `write` in class `OutputStream`
  Parameters:
    `b` - the byte to be written.

### write

    public void write(byte[] b,
                      int off,
                      int len)

  Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.
  Overrides:
    `write` in class `OutputStream`
  Parameters:
    `b` - the data.
    `off` - the start offset in the data.
    `len` - the number of bytes to write.

### writeTo

    public void writeTo(OutputStream out)
                 throws IOException

  Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.
  Parameters:
    `out` - the output stream to which to write the data.
  Throws:
    `IOException` - if an I/O error occurs.

### reset

    public void reset()

  Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the ouput stream is discarded. The output stream can be used again, reusing the already allocated buffer space.
  See Also:
    `ByteArrayInputStream.count`

### toByteArray

    public byte[] toByteArray()

  Creates a newly allocated byte array. Its size is the current size of this output stream and the valid contents of the buffer have been copied into it.
  Returns:
    the current contents of this output stream, as a byte array.
  See Also:
    `size()`

### size

    public int size()

  Returns the current size of the buffer.
  Returns:
    the value of the `count` field, which is the number of valid bytes in this output stream.
  See Also:
    `count`

### toString

    public String toString()

  Converts the buffer's contents into a string, translating bytes into characters according to the platform's default character encoding.
  Overrides:
    `toString` in class `Object`
  Returns:
    String translated from the buffer's contents.
  Since:
    JDK1.1

### toString

    public String toString(String enc)
                    throws UnsupportedEncodingException

  Converts the buffer's contents into a string, translating bytes into characters according to the specified character encoding.
  Parameters:
    `enc` - a character-encoding name.
  Returns:
    String translated from the buffer's contents.
  Throws:
    `UnsupportedEncodingException` - If the named encoding is not supported.
  Since:
    JDK1.1

### close

    public void close()
               throws IOException

  Closes this output stream and releases any system resources associated with this stream. A closed stream cannot perform output operations and cannot be reopened.

  Overrides:
    `close` in class `OutputStream`
  Following copied from class: `java.io.OutputStream`
  Throws:
    `IOException` - if an I/O error occurs.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >